diff --git a/nptl/sysdeps/i386/i586/pthread_spin_trylock.S b/nptl/sysdeps/i386/i586/pthread_spin_trylock.S
deleted file mode 100644
index 9afe82a..0000000
--- a/nptl/sysdeps/i386/i586/pthread_spin_trylock.S
+++ /dev/null
@@ -1,19 +0,0 @@
-/* Copyright (C) 2002-2014 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Ulrich Drepper <drepper@redhat.com>, 2002.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include "../i486/pthread_spin_trylock.S"
diff --git a/nptl/sysdeps/i386/i486/pthread_spin_trylock.S b/sysdeps/i386/i486/nptl/pthread_spin_trylock.S
similarity index 100%
rename from nptl/sysdeps/i386/i486/pthread_spin_trylock.S
rename to sysdeps/i386/i486/nptl/pthread_spin_trylock.S
diff --git a/sysdeps/i386/i586/nptl/pthread_spin_trylock.S b/sysdeps/i386/i586/nptl/pthread_spin_trylock.S
new file mode 100644
index 0000000..a0c90b5
--- /dev/null
+++ b/sysdeps/i386/i586/nptl/pthread_spin_trylock.S
@@ -0,0 +1 @@
+#include <sysdeps/i386/i486/nptl/pthread_spin_trylock.S>
diff --git a/nptl/sysdeps/i386/i686/Makefile b/sysdeps/i386/i686/nptl/Makefile
similarity index 100%
rename from nptl/sysdeps/i386/i686/Makefile
rename to sysdeps/i386/i686/nptl/Makefile
diff --git a/nptl/sysdeps/i386/i686/pthread_spin_trylock.S b/sysdeps/i386/i686/nptl/pthread_spin_trylock.S
similarity index 93%
rename from nptl/sysdeps/i386/i686/pthread_spin_trylock.S
rename to sysdeps/i386/i686/nptl/pthread_spin_trylock.S
index 0ad3d11..d02f490 100644
--- a/nptl/sysdeps/i386/i686/pthread_spin_trylock.S
+++ b/sysdeps/i386/i686/nptl/pthread_spin_trylock.S
@@ -17,4 +17,4 @@
    <http://www.gnu.org/licenses/>.  */
 
 #define HAVE_CMOV	1
-#include "../i486/pthread_spin_trylock.S"
+#include <sysdeps/i386/i486/nptl/pthread_spin_trylock.S>
diff --git a/nptl/sysdeps/i386/i686/tls.h b/sysdeps/i386/i686/nptl/tls.h
similarity index 98%
rename from nptl/sysdeps/i386/i686/tls.h
rename to sysdeps/i386/i686/nptl/tls.h
index 60bf9e1..71e769e 100644
--- a/nptl/sysdeps/i386/i686/tls.h
+++ b/sysdeps/i386/i686/nptl/tls.h
@@ -30,6 +30,6 @@
 
 
 /* Get the full set of definitions.  */
-#include "../tls.h"
+#include_next <tls.h>
 
 #endif	/* tls.h */
diff --git a/nptl/sysdeps/i386/Makefile b/sysdeps/i386/nptl/Makefile
similarity index 100%
rename from nptl/sysdeps/i386/Makefile
rename to sysdeps/i386/nptl/Makefile
diff --git a/nptl/sysdeps/i386/pthread_spin_init.c b/sysdeps/i386/nptl/pthread_spin_init.c
similarity index 100%
rename from nptl/sysdeps/i386/pthread_spin_init.c
rename to sysdeps/i386/nptl/pthread_spin_init.c
diff --git a/nptl/sysdeps/i386/pthread_spin_lock.S b/sysdeps/i386/nptl/pthread_spin_lock.S
similarity index 100%
rename from nptl/sysdeps/i386/pthread_spin_lock.S
rename to sysdeps/i386/nptl/pthread_spin_lock.S
diff --git a/nptl/sysdeps/i386/pthread_spin_unlock.S b/sysdeps/i386/nptl/pthread_spin_unlock.S
similarity index 100%
rename from nptl/sysdeps/i386/pthread_spin_unlock.S
rename to sysdeps/i386/nptl/pthread_spin_unlock.S
diff --git a/nptl/sysdeps/i386/pthreaddef.h b/sysdeps/i386/nptl/pthreaddef.h
similarity index 100%
rename from nptl/sysdeps/i386/pthreaddef.h
rename to sysdeps/i386/nptl/pthreaddef.h
diff --git a/nptl/sysdeps/i386/tcb-offsets.sym b/sysdeps/i386/nptl/tcb-offsets.sym
similarity index 100%
rename from nptl/sysdeps/i386/tcb-offsets.sym
rename to sysdeps/i386/nptl/tcb-offsets.sym
diff --git a/nptl/sysdeps/i386/tls.h b/sysdeps/i386/nptl/tls.h
similarity index 100%
rename from nptl/sysdeps/i386/tls.h
rename to sysdeps/i386/nptl/tls.h
diff --git a/sysdeps/x86_64/nptl/pthread_spin_init.c b/sysdeps/x86_64/nptl/pthread_spin_init.c
index 5569620..f249c6f 100644
--- a/sysdeps/x86_64/nptl/pthread_spin_init.c
+++ b/sysdeps/x86_64/nptl/pthread_spin_init.c
@@ -1 +1 @@
-#include "../i386/pthread_spin_init.c"
+#include <sysdeps/i386/nptl/pthread_spin_init.c>