diff --git a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_init.c b/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_init.c
deleted file mode 100644
index d27e550..0000000
--- a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_init.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sparc64/pthread_spin_init.c>
diff --git a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S b/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S
deleted file mode 100644
index d33b375..0000000
--- a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S
+++ /dev/null
@@ -1 +0,0 @@
-#include <sparc64/pthread_spin_lock.S>
diff --git a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.S b/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.S
deleted file mode 100644
index af5b151..0000000
--- a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.S
+++ /dev/null
@@ -1 +0,0 @@
-#include <sparc64/pthread_spin_trylock.S>
diff --git a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.S b/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.S
deleted file mode 100644
index c40d80f..0000000
--- a/nptl/sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.S
+++ /dev/null
@@ -1 +0,0 @@
-#include <sparc64/pthread_spin_unlock.S>
diff --git a/nptl/sysdeps/sparc/Makefile b/sysdeps/sparc/nptl/Makefile
similarity index 100%
rename from nptl/sysdeps/sparc/Makefile
rename to sysdeps/sparc/nptl/Makefile
diff --git a/nptl/sysdeps/sparc/tcb-offsets.sym b/sysdeps/sparc/nptl/tcb-offsets.sym
similarity index 100%
rename from nptl/sysdeps/sparc/tcb-offsets.sym
rename to sysdeps/sparc/nptl/tcb-offsets.sym
diff --git a/nptl/sysdeps/sparc/tls.h b/sysdeps/sparc/nptl/tls.h
similarity index 100%
rename from nptl/sysdeps/sparc/tls.h
rename to sysdeps/sparc/nptl/tls.h
diff --git a/nptl/sysdeps/sparc/sparc32/pthread_spin_lock.S b/sysdeps/sparc/sparc32/nptl/pthread_spin_lock.S
similarity index 100%
rename from nptl/sysdeps/sparc/sparc32/pthread_spin_lock.S
rename to sysdeps/sparc/sparc32/nptl/pthread_spin_lock.S
diff --git a/nptl/sysdeps/sparc/sparc32/pthread_spin_trylock.S b/sysdeps/sparc/sparc32/nptl/pthread_spin_trylock.S
similarity index 100%
rename from nptl/sysdeps/sparc/sparc32/pthread_spin_trylock.S
rename to sysdeps/sparc/sparc32/nptl/pthread_spin_trylock.S
diff --git a/nptl/sysdeps/sparc/sparc32/pthreaddef.h b/sysdeps/sparc/sparc32/nptl/pthreaddef.h
similarity index 100%
rename from nptl/sysdeps/sparc/sparc32/pthreaddef.h
rename to sysdeps/sparc/sparc32/nptl/pthreaddef.h
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_init.c b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_init.c
new file mode 100644
index 0000000..c8edcb0
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_init.c
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/nptl/pthread_spin_init.c>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_lock.S b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_lock.S
new file mode 100644
index 0000000..f2b898d
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_lock.S
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/nptl/pthread_spin_lock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_trylock.S b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_trylock.S
new file mode 100644
index 0000000..b324906
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_trylock.S
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/nptl/pthread_spin_trylock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_unlock.S b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_unlock.S
new file mode 100644
index 0000000..8c56ebe
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_unlock.S
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/nptl/pthread_spin_unlock.S>
diff --git a/nptl/sysdeps/sparc/sparc64/pthread_spin_init.c b/sysdeps/sparc/sparc64/nptl/pthread_spin_init.c
similarity index 100%
rename from nptl/sysdeps/sparc/sparc64/pthread_spin_init.c
rename to sysdeps/sparc/sparc64/nptl/pthread_spin_init.c
diff --git a/nptl/sysdeps/sparc/sparc64/pthread_spin_lock.S b/sysdeps/sparc/sparc64/nptl/pthread_spin_lock.S
similarity index 100%
rename from nptl/sysdeps/sparc/sparc64/pthread_spin_lock.S
rename to sysdeps/sparc/sparc64/nptl/pthread_spin_lock.S
diff --git a/nptl/sysdeps/sparc/sparc64/pthread_spin_trylock.S b/sysdeps/sparc/sparc64/nptl/pthread_spin_trylock.S
similarity index 100%
rename from nptl/sysdeps/sparc/sparc64/pthread_spin_trylock.S
rename to sysdeps/sparc/sparc64/nptl/pthread_spin_trylock.S
diff --git a/nptl/sysdeps/sparc/sparc64/pthread_spin_unlock.S b/sysdeps/sparc/sparc64/nptl/pthread_spin_unlock.S
similarity index 100%
rename from nptl/sysdeps/sparc/sparc64/pthread_spin_unlock.S
rename to sysdeps/sparc/sparc64/nptl/pthread_spin_unlock.S
diff --git a/nptl/sysdeps/sparc/sparc64/pthreaddef.h b/sysdeps/sparc/sparc64/nptl/pthreaddef.h
similarity index 100%
rename from nptl/sysdeps/sparc/sparc64/pthreaddef.h
rename to sysdeps/sparc/sparc64/nptl/pthreaddef.h