diff --git a/sysdeps/sparc/sparc32/nptl/lowlevellock.c b/sysdeps/sparc/sparc32/lowlevellock.c
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/lowlevellock.c
rename to sysdeps/sparc/sparc32/lowlevellock.c
diff --git a/sysdeps/sparc/sparc32/nptl/pthread_barrier_wait.c b/sysdeps/sparc/sparc32/pthread_barrier_wait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/pthread_barrier_wait.c
rename to sysdeps/sparc/sparc32/pthread_barrier_wait.c
diff --git a/sysdeps/sparc/sparc32/nptl/pthread_spin_lock.S b/sysdeps/sparc/sparc32/pthread_spin_lock.S
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/pthread_spin_lock.S
rename to sysdeps/sparc/sparc32/pthread_spin_lock.S
diff --git a/sysdeps/sparc/sparc32/nptl/pthread_spin_trylock.S b/sysdeps/sparc/sparc32/pthread_spin_trylock.S
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/pthread_spin_trylock.S
rename to sysdeps/sparc/sparc32/pthread_spin_trylock.S
diff --git a/sysdeps/sparc/sparc32/nptl/pthreaddef.h b/sysdeps/sparc/sparc32/pthreaddef.h
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/pthreaddef.h
rename to sysdeps/sparc/sparc32/pthreaddef.h
diff --git a/sysdeps/sparc/sparc32/nptl/sem_post.c b/sysdeps/sparc/sparc32/sem_post.c
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/sem_post.c
rename to sysdeps/sparc/sparc32/sem_post.c
diff --git a/sysdeps/sparc/sparc32/nptl/sem_timedwait.c b/sysdeps/sparc/sparc32/sem_timedwait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/sem_timedwait.c
rename to sysdeps/sparc/sparc32/sem_timedwait.c
diff --git a/sysdeps/sparc/sparc32/nptl/sem_trywait.c b/sysdeps/sparc/sparc32/sem_trywait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/sem_trywait.c
rename to sysdeps/sparc/sparc32/sem_trywait.c
diff --git a/sysdeps/sparc/sparc32/nptl/sem_wait.c b/sysdeps/sparc/sparc32/sem_wait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/nptl/sem_wait.c
rename to sysdeps/sparc/sparc32/sem_wait.c
diff --git a/sysdeps/sparc/sparc32/sparcv9/cpu_relax.S b/sysdeps/sparc/sparc32/sparcv9/cpu_relax.S
new file mode 100644
index 0000000..41a5e72
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/cpu_relax.S
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/cpu_relax.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/cpu_relax.S b/sysdeps/sparc/sparc32/sparcv9/nptl/cpu_relax.S
deleted file mode 100644
index fa88647..0000000
--- a/sysdeps/sparc/sparc32/sparcv9/nptl/cpu_relax.S
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/sparc/sparc64/nptl/cpu_relax.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_init.c b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_init.c
deleted file mode 100644
index c8edcb0..0000000
--- a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_init.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/sparc/sparc64/nptl/pthread_spin_init.c>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_lock.S b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_lock.S
deleted file mode 100644
index f2b898d..0000000
--- a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_lock.S
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/sparc/sparc64/nptl/pthread_spin_lock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_trylock.S b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_trylock.S
deleted file mode 100644
index b324906..0000000
--- a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_trylock.S
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/sparc/sparc64/nptl/pthread_spin_trylock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_unlock.S b/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_unlock.S
deleted file mode 100644
index 8c56ebe..0000000
--- a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_spin_unlock.S
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/sparc/sparc64/nptl/pthread_spin_unlock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/pthread_barrier_wait.c b/sysdeps/sparc/sparc32/sparcv9/pthread_barrier_wait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/sparcv9/nptl/pthread_barrier_wait.c
rename to sysdeps/sparc/sparc32/sparcv9/pthread_barrier_wait.c
diff --git a/sysdeps/sparc/sparc32/sparcv9/pthread_spin_init.c b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_init.c
new file mode 100644
index 0000000..1eede86
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_init.c
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/pthread_spin_init.c>
diff --git a/sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S
new file mode 100644
index 0000000..ce53dfa
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/pthread_spin_lock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.S b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.S
new file mode 100644
index 0000000..ffd632d
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.S
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/pthread_spin_trylock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.S b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.S
new file mode 100644
index 0000000..983c803
--- /dev/null
+++ b/sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.S
@@ -0,0 +1 @@
+#include <sysdeps/sparc/sparc64/pthread_spin_unlock.S>
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/sem_post.c b/sysdeps/sparc/sparc32/sparcv9/sem_post.c
similarity index 100%
rename from sysdeps/sparc/sparc32/sparcv9/nptl/sem_post.c
rename to sysdeps/sparc/sparc32/sparcv9/sem_post.c
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/sem_timedwait.c b/sysdeps/sparc/sparc32/sparcv9/sem_timedwait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/sparcv9/nptl/sem_timedwait.c
rename to sysdeps/sparc/sparc32/sparcv9/sem_timedwait.c
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/sem_trywait.c b/sysdeps/sparc/sparc32/sparcv9/sem_trywait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/sparcv9/nptl/sem_trywait.c
rename to sysdeps/sparc/sparc32/sparcv9/sem_trywait.c
diff --git a/sysdeps/sparc/sparc32/sparcv9/nptl/sem_wait.c b/sysdeps/sparc/sparc32/sparcv9/sem_wait.c
similarity index 100%
rename from sysdeps/sparc/sparc32/sparcv9/nptl/sem_wait.c
rename to sysdeps/sparc/sparc32/sparcv9/sem_wait.c
diff --git a/sysdeps/sparc/sparc64/Makefile b/sysdeps/sparc/sparc64/Makefile
index fb161ea..dd3023d 100644
--- a/sysdeps/sparc/sparc64/Makefile
+++ b/sysdeps/sparc/sparc64/Makefile
@@ -14,3 +14,7 @@ ASFLAGS-.op += -Wa,-Av9d
 ASFLAGS-.og += -Wa,-Av9d
 ASFLAGS-.oS += -Wa,-Av9d
 endif
+
+ifeq ($(subdir),nptl)
+libpthread-routines += cpu_relax
+endif
diff --git a/sysdeps/sparc/sparc64/nptl/cpu_relax.S b/sysdeps/sparc/sparc64/cpu_relax.S
similarity index 100%
rename from sysdeps/sparc/sparc64/nptl/cpu_relax.S
rename to sysdeps/sparc/sparc64/cpu_relax.S
diff --git a/sysdeps/sparc/sparc64/nptl/Makefile b/sysdeps/sparc/sparc64/nptl/Makefile
deleted file mode 100644
index ddc9038..0000000
--- a/sysdeps/sparc/sparc64/nptl/Makefile
+++ /dev/null
@@ -1,3 +0,0 @@
-ifeq ($(subdir),nptl)
-libpthread-routines += cpu_relax
-endif
diff --git a/sysdeps/sparc/sparc64/nptl/pthread_spin_init.c b/sysdeps/sparc/sparc64/pthread_spin_init.c
similarity index 100%
rename from sysdeps/sparc/sparc64/nptl/pthread_spin_init.c
rename to sysdeps/sparc/sparc64/pthread_spin_init.c
diff --git a/sysdeps/sparc/sparc64/nptl/pthread_spin_lock.S b/sysdeps/sparc/sparc64/pthread_spin_lock.S
similarity index 100%
rename from sysdeps/sparc/sparc64/nptl/pthread_spin_lock.S
rename to sysdeps/sparc/sparc64/pthread_spin_lock.S
diff --git a/sysdeps/sparc/sparc64/nptl/pthread_spin_trylock.S b/sysdeps/sparc/sparc64/pthread_spin_trylock.S
similarity index 100%
rename from sysdeps/sparc/sparc64/nptl/pthread_spin_trylock.S
rename to sysdeps/sparc/sparc64/pthread_spin_trylock.S
diff --git a/sysdeps/sparc/sparc64/nptl/pthread_spin_unlock.S b/sysdeps/sparc/sparc64/pthread_spin_unlock.S
similarity index 100%
rename from sysdeps/sparc/sparc64/nptl/pthread_spin_unlock.S
rename to sysdeps/sparc/sparc64/pthread_spin_unlock.S
diff --git a/sysdeps/sparc/sparc64/nptl/pthreaddef.h b/sysdeps/sparc/sparc64/pthreaddef.h
similarity index 100%
rename from sysdeps/sparc/sparc64/nptl/pthreaddef.h
rename to sysdeps/sparc/sparc64/pthreaddef.h